package meerkat.bulletinboard.workers.multiserver;

import com.google.common.util.concurrent.FutureCallback;
import com.google.protobuf.Timestamp;
import meerkat.bulletinboard.AsyncBulletinBoardClient.BatchIdentifier;
import meerkat.bulletinboard.SingleServerBulletinBoardClient;
import meerkat.protobuf.Crypto.Signature;

import java.util.List;

/**
 * Created by Arbel Deutsch Peled on 27-Dec-15.
 */
public class MultiServerCloseBatchWorker extends MultiServerGenericPostWorker<BatchIdentifier> {

    private final Timestamp timestamp;
    private final Iterable<Signature> signatures;

    public MultiServerCloseBatchWorker(List<SingleServerBulletinBoardClient> clients, int minServers,
                                       BatchIdentifier payload, Timestamp timestamp, Iterable<Signature> signatures,
                                       int maxRetry, FutureCallback<Boolean> futureCallback) {

        super(clients, minServers, payload, maxRetry, futureCallback);

        this.timestamp = timestamp;
        this.signatures = signatures;

    }

    @Override
    protected void doPost(SingleServerBulletinBoardClient client, BatchIdentifier payload) {
        client.closeBatch(payload, timestamp, signatures, this);
    }


}
